<html>
      <head>
        <meta charset="UTF-8">
        <title>README.md</title>
      </head>
      <body>
        <h2 id="how-does-bootstrap-s-test-suite-work-">How does Bootstrap&#39;s test suite work?</h2>
<p>Bootstrap uses <a href="https://qunitjs.com/">QUnit</a>, a powerful, easy-to-use JavaScript unit test framework. Each plugin has a file dedicated to its tests in <code>unit/&lt;plugin-name&gt;.js</code>.</p>
<ul>
<li><code>unit/</code> contains the unit test files for each Bootstrap plugin.</li>
<li><code>vendor/</code> contains third-party testing-related code (QUnit and jQuery).</li>
<li><code>visual/</code> contains &quot;visual&quot; tests which are run interactively in real browsers and require manual verification by humans.</li>
</ul>
<p>To run the unit test suite via <a href="http://phantomjs.org/">PhantomJS</a>, run <code>npm run js-test</code>.</p>
<p>To run the unit test suite via a real web browser, open <code>index.html</code> in the browser.</p>
<h2 id="how-do-i-add-a-new-unit-test-">How do I add a new unit test?</h2>
<ol>
<li>Locate and open the file dedicated to the plugin which you need to add tests to (<code>unit/&lt;plugin-name&gt;.js</code>).</li>
<li>Review the <a href="https://api.qunitjs.com/">QUnit API Documentation</a> and use the existing tests as references for how to structure your new tests.</li>
<li>Write the necessary unit test(s) for the new or revised functionality.</li>
<li>Run <code>npm run js-test</code> to see the results of your newly-added test(s).</li>
</ol>
<p><strong>Note:</strong> Your new unit tests should fail before your changes are applied to the plugin, and should pass after your changes are applied to the plugin.</p>
<h2 id="what-should-a-unit-test-look-like-">What should a unit test look like?</h2>
<ul>
<li>Each test should have a unique name clearly stating what unit is being tested.</li>
<li>Each test should test only one unit per test, although one test can include several assertions. Create multiple tests for multiple units of functionality.</li>
<li>Each test should begin with <a href="https://api.qunitjs.com/assert/expect/"><code>assert.expect</code></a> to ensure that the expected assertions are run.</li>
<li>Each test should follow the project&#39;s <a href="https://github.com/twbs/bootstrap/blob/master/CONTRIBUTING.md#js">JavaScript Code Guidelines</a></li>
</ul>
<h3 id="example-tests">Example tests</h3>
<pre><code class="lang-javascript">// Synchronous test
QUnit.test(&#39;should describe the unit being tested&#39;, function (assert) {
  assert.expect(1)
  var templateHTML = &#39;&lt;div class=&quot;alert alert-danger fade show&quot;&gt;&#39;
      + &#39;&lt;a class=&quot;close&quot; href=&quot;#&quot; data-dismiss=&quot;alert&quot;&gt;×&lt;/a&gt;&#39;
      + &#39;&lt;p&gt;&lt;strong&gt;Template necessary for the test.&lt;/p&gt;&#39;
      + &#39;&lt;/div&gt;&#39;
  var $alert = $(templateHTML).appendTo(&#39;#qunit-fixture&#39;).bootstrapAlert()

  $alert.find(&#39;.close&#39;).trigger(&#39;click&#39;)

  // Make assertion
  assert.strictEqual($alert.hasClass(&#39;show&#39;), false, &#39;remove .show class on .close click&#39;)
})

// Asynchronous test
QUnit.test(&#39;should describe the unit being tested&#39;, function (assert) {
  assert.expect(1)
  var done = assert.async()

  $(&#39;&lt;div title=&quot;tooltip title&quot;&gt;&lt;/div&gt;&#39;)
    .appendTo(&#39;#qunit-fixture&#39;)
    .on(&#39;shown.bs.tooltip&#39;, function () {
      assert.ok(true, &#39;&quot;shown&quot; event was fired after calling &quot;show&quot;&#39;)
      done()
    })
    .bootstrapTooltip(&#39;show&#39;)
})
</code></pre>

      </body>
    </html>